searchNodes=[{"doc":"ExConstructor is an Elixir library that makes it easy to instantiate structs from external data, such as that emitted by a JSON parser. Add use ExConstructor after a defstruct statement to inject a constructor function into the module. The generated constructor, called new by default, handles map-vs-keyword-list, string-vs-atom-keys, and camelCase-vs-under_score input data issues automatically, DRYing up your code and letting you move on to the interesting parts of your program. Installation Add ExConstructor to your list of dependencies in mix.exs : def deps do [ { :exconstructor , &quot;~&gt; 1.2.1&quot; } ] end Usage Example: defmodule TestStruct do defstruct field_one : 1 , field_two : 2 , field_three : 3 , field_four : 4 , use ExConstructor end TestStruct . new ( %{ &quot;field_one&quot; =&gt; &quot;a&quot; , &quot;fieldTwo&quot; =&gt; &quot;b&quot; , :field_three =&gt; &quot;c&quot; , :FieldFour =&gt; &quot;d&quot; } ) # =&gt; %TestStruct{field_one: &quot;a&quot;, field_two: &quot;b&quot;, field_three: &quot;c&quot;, field_four: &quot;d&quot;} For advanced usage, see __using__/1 and populate_struct/3 . Authorship and License ExConstructor is copyright 2016-2021 Appcues, Inc. ExConstructor is released under the MIT License .","ref":"ExConstructor.html","title":"ExConstructor","type":"module"},{"doc":"use ExConstructor defines a constructor for the current module's struct. If name_or_opts is an atom, it will be used as the constructor name. If name_or_opts is a keyword list, name_or_opts[:name] will be used as the constructor name. By default, :new is used. Additional options in name_or_opts are stored in the @exconstructor_default_options module attribute. The constructor is implemented in terms of populate_struct/3 . It accepts a map or keyword list of keys and values map_or_kwlist , and an optional opts keyword list. Keys of map_or_kwlist may be strings or atoms, in camelCase or under_score format. opts may contain keys strings , atoms , camelcase and underscore . Set these keys false to prevent testing of that key format in map_or_kwlist . All default to true . For the default name :new , the constructor's definition looks like: @spec new ( ExConstructor . map_or_kwlist , Keyword . t ) :: % __MODULE__ { } def new ( map_or_kwlist , opts \\\\ [ ] ) do ExConstructor . populate_struct ( % __MODULE__ { } , map_or_kwlist , Keyword . merge ( @exconstructor_default_options , opts ) ) end defoverridable [ new : 1 , new : 2 ] Overriding new/2 is allowed; the generated function can be called by super . Example uses include implementing your own opts handling.","ref":"ExConstructor.html#__using__/1","title":"ExConstructor.__using__/1","type":"macro"},{"doc":"Alias for __using__ , for those who prefer an explicit invocation.","ref":"ExConstructor.html#define_constructor/1","title":"ExConstructor.define_constructor/1","type":"macro"},{"doc":"Returns a copy of struct into which the values in map_or_kwlist have been applied. Keys of map_or_kwlist may be strings or atoms, in camelCase or under_score format.","ref":"ExConstructor.html#populate_struct/2","title":"ExConstructor.populate_struct/2","type":"function"},{"doc":"Returns a copy of struct into which the values in map_or_kwlist have been applied. Keys of map_or_kwlist may be strings or atoms, in camelCase, UpperCamelCase, or under_score format. opts may contain keys strings , atoms , camelcase , uppercamelcase , and underscore . Set these keys false to prevent testing of that key format in map_or_kwlist . All default to true .","ref":"ExConstructor.html#populate_struct/3","title":"ExConstructor.populate_struct/3","type":"function"},{"doc":"","ref":"ExConstructor.html#t:map_or_kwlist/0","title":"ExConstructor.map_or_kwlist/0","type":"type"},{"doc":"Represents the options passed to populate_struct/3 . Set any value to false to disable checking for that kind of key.","ref":"ExConstructor.Options.html","title":"ExConstructor.Options","type":"module"}]